# Changes added on 2020-04-26:
# added "positioned ~ 63 ~" to /tag @e[tag=wave] to make sure shells spawn whatever is the y position of the wave spawners
# added commands to kill each shell after 1 minute
# added second step of randomization
# 2020-04-27 - added command to change shells' rotation
# 2020-04-28 - changed CustomModelData of shells

# 2020-08-03
# The "63" you can see in many commands is the sea level +1 of the world; if your world has a different sea level, change this number

# Waves randomizer - every 150 ticks, a wave is spawned on one of the stands

# The stand at the center of the island is rotated to always face the player
execute as @e[tag=island_centre] at @s facing entity @p feet run tp @s ~ ~ ~ ~ 0

# The stands on which the waves are spawned circle around the island following the player
execute as @e[tag=wave_spawner,tag=0] at @e[tag=island_centre] run tp @s ^ ^ ^245
execute as @e[tag=wave_spawner,tag=1] at @e[tag=island_centre] run tp @s ^12 ^ ^246
execute as @e[tag=wave_spawner,tag=2] at @e[tag=island_centre] run tp @s ^25 ^ ^246
execute as @e[tag=wave_spawner,tag=3] at @e[tag=island_centre] run tp @s ^-12 ^ ^244
execute as @e[tag=wave_spawner,tag=4] at @e[tag=island_centre] run tp @s ^-25 ^ ^244
# If you add more of these stand, you will also need to add a command like this for each of them
# Change the coordinates to reflect the size of your island

# Scoreboard controller
scoreboard players add waves wave 1
execute if score waves wave matches 120 run scoreboard players set waves wave 0
# This command will spawn a wave on a random stand every 150 ticks
execute as @e[tag=wave_spawner,limit=1,sort=random] at @s if score waves wave matches 1 run summon area_effect_cloud ~ 63 ~ {NoGravity:true,Tags:["wave"],Duration:999999}

# Second step of randomization: island_centre moves randomly, moving in this way also the wave spawners
# Change the coordinates of spreadplayers to be the island's center (you can also customize the range), but remember that it works only if there's ground around it
execute if score waves wave matches 0 run spreadplayers 258 258 0 10 false @e[tag=island_centre]
execute if score waves wave matches 0 run execute as @e[tag=island_centre] at @s run tp @s ~ 64 ~

# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Wave controller - creates the wave

# Each wave is oriented to face the centre of the island
execute as @e[tag=wave] at @s facing entity @e[tag=island_centre] feet run tp @s ~ ~ ~ ~ 0
# Each wave is directed towards the centre of the island
execute as @e[tag=wave,tag=!wave_back] at @s run tp @s ^ ^ ^0.2

# 20 ticks after a wave has reached the beach, it is made turning back for 15 ticks and then killed by using the timer of the area effect cloud used as a marker for the wave
# The timer is kept at 1000 as long as the marker is on top of water
execute as @e[tag=wave,tag=!wave_back] at @s if block ~ ~-1 ~ water run data merge entity @s {Age:1000}
# Once the marker is no longer on top of water, the timer is free to increase
execute as @e[tag=wave,nbt={Age:1020}] run tag @s add wave_back
execute as @e[tag=wave,tag=wave_back] at @s run tp @s ^ ^ ^-0.2
execute as @e[tag=wave,nbt={Age:1035}] run kill @s


# Life cycle of the wave, controlled by the distance from the beach ("unless block ^ ^-1 ^X water")

# Fully formed wave
execute as @e[tag=wave] at @s if block ^ ^-1 ^-4 water unless block ^ ^-1 ^15 water positioned ^ ^ ^ run fill ^ ^ ^ ^ ^ ^ water[level=1] replace air
execute as @e[tag=wave] at @s if block ^ ^-1 ^-4 water unless block ^ ^-1 ^15 water positioned ^1 ^ ^ run fill ^ ^ ^ ^ ^ ^ water[level=1] replace air
execute as @e[tag=wave] at @s if block ^ ^-1 ^-4 water unless block ^ ^-1 ^15 water positioned ^-1 ^ ^ run fill ^ ^ ^ ^ ^ ^ water[level=1] replace air
execute as @e[tag=wave] at @s if block ^ ^-1 ^-4 water unless block ^ ^-1 ^15 water positioned ^2 ^ ^ run fill ^ ^ ^ ^ ^ ^ water[level=1] replace air
execute as @e[tag=wave] at @s if block ^ ^-1 ^-4 water unless block ^ ^-1 ^15 water positioned ^-2 ^ ^ run fill ^ ^ ^ ^ ^ ^ water[level=1] replace air
execute as @e[tag=wave] at @s if block ^ ^-1 ^-4 water unless block ^ ^-1 ^15 water positioned ^3 ^ ^ run fill ^ ^ ^ ^ ^ ^ water[level=1] replace air
execute as @e[tag=wave] at @s if block ^ ^-1 ^-4 water unless block ^ ^-1 ^15 water positioned ^-3 ^ ^ run fill ^ ^ ^ ^ ^ ^ water[level=1] replace air
execute as @e[tag=wave] at @s if block ^ ^-1 ^-4 water unless block ^ ^-1 ^15 water positioned ^4 ^ ^ run fill ^ ^ ^ ^ ^ ^ water[level=4] replace air
execute as @e[tag=wave] at @s if block ^ ^-1 ^-4 water unless block ^ ^-1 ^15 water positioned ^-4 ^ ^ run fill ^ ^ ^ ^ ^ ^ water[level=4] replace air

# Once the wave reaches the beach, the wave starts to disperd
# Every water and air block is replaced by low water to simulate the wave being absorbed by the beach
execute as @e[tag=wave,tag=wave_back] at @s positioned ^ ^ ^ run fill ^ ^ ^ ^ ^ ^ water[level=7] replace water
execute as @e[tag=wave,tag=wave_back] at @s positioned ^1 ^ ^ run fill ^ ^ ^ ^ ^ ^ water[level=7] replace water
execute as @e[tag=wave,tag=wave_back] at @s positioned ^-1 ^ ^ run fill ^ ^ ^ ^ ^ ^ water[level=7] replace water
execute as @e[tag=wave,tag=wave_back] at @s positioned ^2 ^ ^ run fill ^ ^ ^ ^ ^ ^ water[level=7] replace water
execute as @e[tag=wave,tag=wave_back] at @s positioned ^-2 ^ ^ run fill ^ ^ ^ ^ ^ ^ water[level=7] replace water
execute as @e[tag=wave,tag=wave_back] at @s positioned ^3 ^ ^ run fill ^ ^ ^ ^ ^ ^ water[level=7] replace water
execute as @e[tag=wave,tag=wave_back] at @s positioned ^-3 ^ ^ run fill ^ ^ ^ ^ ^ ^ water[level=7] replace water
execute as @e[tag=wave,tag=wave_back] at @s positioned ^4 ^ ^ run fill ^ ^ ^ ^ ^ ^ water[level=7] replace water
execute as @e[tag=wave,tag=wave_back] at @s positioned ^-4 ^ ^ run fill ^ ^ ^ ^ ^ ^ water[level=7] replace water

execute as @e[tag=wave,tag=wave_back] at @s positioned ^ ^ ^ run fill ^ ^ ^ ^ ^ ^-1 water[level=7] replace air
execute as @e[tag=wave,tag=wave_back] at @s positioned ^1 ^ ^ run fill ^ ^ ^ ^ ^ ^-1 water[level=7] replace air
execute as @e[tag=wave,tag=wave_back] at @s positioned ^-1 ^ ^ run fill ^ ^ ^ ^ ^ ^-1 water[level=7] replace air
execute as @e[tag=wave,tag=wave_back] at @s positioned ^2 ^ ^ run fill ^ ^ ^ ^ ^ ^-1 water[level=7] replace air
execute as @e[tag=wave,tag=wave_back] at @s positioned ^-2 ^ ^ run fill ^ ^ ^ ^ ^ ^-1 water[level=7] replace air
execute as @e[tag=wave,tag=wave_back] at @s positioned ^3 ^ ^ run fill ^ ^ ^ ^ ^ ^-1 water[level=7] replace air
execute as @e[tag=wave,tag=wave_back] at @s positioned ^-3 ^ ^ run fill ^ ^ ^ ^ ^ ^-1 water[level=7] replace air
execute as @e[tag=wave,tag=wave_back] at @s positioned ^4 ^ ^ run fill ^ ^ ^ ^ ^ ^-1 water[level=7] replace air
execute as @e[tag=wave,tag=wave_back] at @s positioned ^-4 ^ ^ run fill ^ ^ ^ ^ ^ ^-1 water[level=7] replace air

# Any water block now behind the wave is set to air to simulate the retreat of the wave
execute as @e[tag=wave,tag=wave_back] at @s positioned ^ ^ ^ run fill ^ ^ ^1 ^ ^ ^1 air replace water
execute as @e[tag=wave,tag=wave_back] at @s positioned ^1 ^ ^ run fill ^ ^ ^1 ^ ^ ^1 air replace water
execute as @e[tag=wave,tag=wave_back] at @s positioned ^-1 ^ ^ run fill ^ ^ ^1 ^ ^ ^1 air replace water
execute as @e[tag=wave,tag=wave_back] at @s positioned ^2 ^ ^ run fill ^ ^ ^1 ^ ^ ^1 air replace water
execute as @e[tag=wave,tag=wave_back] at @s positioned ^-2 ^ ^ run fill ^ ^ ^1 ^ ^ ^1 air replace water
execute as @e[tag=wave,tag=wave_back] at @s positioned ^3 ^ ^ run fill ^ ^ ^1 ^ ^ ^1 air replace water
execute as @e[tag=wave,tag=wave_back] at @s positioned ^-3 ^ ^ run fill ^ ^ ^1 ^ ^ ^1 air replace water
execute as @e[tag=wave,tag=wave_back] at @s positioned ^4 ^ ^ run fill ^ ^ ^1 ^ ^ ^1 air replace water
execute as @e[tag=wave,tag=wave_back] at @s positioned ^-4 ^ ^ run fill ^ ^ ^1 ^ ^ ^1 air replace water

# At the beginning, the wave is smaller
execute as @e[tag=wave] at @s if block ~ ~-1 ~4 water positioned ^ ^ ^ run fill ^ ^ ^ ^ ^ ^ water[level=6] replace air
execute as @e[tag=wave] at @s if block ~ ~-1 ~4 water positioned ^1 ^ ^ run fill ^ ^ ^ ^ ^ ^ water[level=6] replace air
execute as @e[tag=wave] at @s if block ~ ~-1 ~4 water positioned ^-1 ^ ^ run fill ^ ^ ^ ^ ^ ^ water[level=6] replace air
execute as @e[tag=wave] at @s if block ~ ~-1 ~4 water positioned ^2 ^ ^ run fill ^ ^ ^ ^ ^ ^ water[level=6] replace air
execute as @e[tag=wave] at @s if block ~ ~-1 ~4 water positioned ^-2 ^ ^ run fill ^ ^ ^ ^ ^ ^ water[level=6] replace air

execute as @e[tag=wave] at @s if block ~ ~-1 ~4 water unless block ^ ^-1 ^40 water positioned ^ ^ ^ run fill ^ ^ ^ ^ ^ ^ water[level=5] replace air
execute as @e[tag=wave] at @s if block ~ ~-1 ~4 water unless block ^ ^-1 ^40 water positioned ^1 ^ ^ run fill ^ ^ ^ ^ ^ ^ water[level=5] replace air
execute as @e[tag=wave] at @s if block ~ ~-1 ~4 water unless block ^ ^-1 ^40 water positioned ^-1 ^ ^ run fill ^ ^ ^ ^ ^ ^ water[level=5] replace air
execute as @e[tag=wave] at @s if block ~ ~-1 ~4 water unless block ^ ^-1 ^40 water positioned ^2 ^ ^ run fill ^ ^ ^ ^ ^ ^ water[level=5] replace air
execute as @e[tag=wave] at @s if block ~ ~-1 ~4 water unless block ^ ^-1 ^40 water positioned ^-2 ^ ^ run fill ^ ^ ^ ^ ^ ^ water[level=5] replace air

execute as @e[tag=wave] at @s if block ~ ~-1 ~4 water unless block ^ ^-1 ^25 water positioned ^ ^ ^ run fill ^ ^ ^ ^ ^ ^ water[level=3] replace air
execute as @e[tag=wave] at @s if block ~ ~-1 ~4 water unless block ^ ^-1 ^25 water positioned ^1 ^ ^ run fill ^ ^ ^ ^ ^ ^ water[level=3] replace air
execute as @e[tag=wave] at @s if block ~ ~-1 ~4 water unless block ^ ^-1 ^25 water positioned ^-1 ^ ^ run fill ^ ^ ^ ^ ^ ^ water[level=3] replace air
execute as @e[tag=wave] at @s if block ~ ~-1 ~4 water unless block ^ ^-1 ^25 water positioned ^2 ^ ^ run fill ^ ^ ^ ^ ^ ^ water[level=3] replace air
execute as @e[tag=wave] at @s if block ~ ~-1 ~4 water unless block ^ ^-1 ^25 water positioned ^-2 ^ ^ run fill ^ ^ ^ ^ ^ ^ water[level=3] replace air
execute as @e[tag=wave] at @s if block ~ ~-1 ~4 water unless block ^ ^-1 ^25 water positioned ^3 ^ ^ run fill ^ ^ ^ ^ ^ ^ water[level=3] replace air
execute as @e[tag=wave] at @s if block ~ ~-1 ~4 water unless block ^ ^-1 ^25 water positioned ^-3 ^ ^ run fill ^ ^ ^ ^ ^ ^ water[level=3] replace air


# The wave's sound grows when closer to the beach
execute as @e[tag=wave,tag=!wave_back] at @s if block ~ ~-1 ~ water unless block ^ ^-1 ^20 water run playsound minecraft:weather.rain.above master @a ~ ~ ~ 0.01
execute as @e[tag=wave,tag=!wave_back] at @s if block ~ ~-1 ~ water unless block ^ ^-1 ^15 water run playsound minecraft:weather.rain.above master @a ~ ~ ~ 0.025

# The closer the wave is to the beach and more particles appears on the wave crest
execute as @e[tag=wave,tag=!wave_back] at @s unless block ^ ^-1 ^9 water positioned ^ ^ ^ run particle minecraft:item cobweb ^ ^0.4 ^0.2 0.3 0.1 0.3 0.01 7 force
execute as @e[tag=wave,tag=!wave_back] at @s unless block ^ ^-1 ^9 water positioned ^1 ^ ^ run particle minecraft:item cobweb ^ ^0.4 ^0.2 0.3 0.1 0.3 0.01 6 force
execute as @e[tag=wave,tag=!wave_back] at @s unless block ^ ^-1 ^9 water positioned ^-1 ^ ^ run particle minecraft:item cobweb ^ ^0.4 ^0.2 0.3 0.1 0.3 0.01 6 force
execute as @e[tag=wave,tag=!wave_back] at @s unless block ^ ^-1 ^7 water positioned ^2 ^ ^ run particle minecraft:item cobweb ^ ^0.4 ^0.2 0.3 0.1 0.3 0.01 6 force
execute as @e[tag=wave,tag=!wave_back] at @s unless block ^ ^-1 ^7 water positioned ^-2 ^ ^ run particle minecraft:item cobweb ^ ^0.4 ^0.2 0.3 0.1 0.3 0.01 6 force
execute as @e[tag=wave,tag=!wave_back] at @s unless block ^ ^-1 ^5 water positioned ^3 ^ ^ run particle minecraft:item cobweb ^ ^0.4 ^0.2 0.3 0.1 0.3 0.01 5 force
execute as @e[tag=wave,tag=!wave_back] at @s unless block ^ ^-1 ^5 water positioned ^-3 ^ ^ run particle minecraft:item cobweb ^ ^0.4 ^0.2 0.3 0.1 0.3 0.01 5 force

# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Shell spawner (needs resource pack)

# Each wave has a chance to spawn a shell (the probability depends from "distance=")
execute at @e[tag=wave_spawner,limit=1,sort=random] positioned ~ 63 ~ run execute as @e[tag=wave,distance=..0.3] run tag @s add wave_shell1
execute at @e[tag=wave_spawner,limit=1,sort=random] positioned ~ 63 ~ run execute as @e[tag=wave,distance=..0.3] run tag @s add wave_shell2
# If the wave has one of these tags, it will spawn one of two type of shells; if it has both it will spawn a third type
execute as @e[tag=wave_shell1,tag=!wave_shell2,nbt={Age:1018}] at @s unless entity @e[tag=shell,distance=..7] if block ~ ~ ~ water run summon armor_stand ~ ~-1.82 ~ {Invisible:true,NoGravity:true,Marker:true,Fire:100s,ArmorItems:[{},{},{},{id:nautilus_shell,Count:1b,tag:{CustomModelData:1}}],Tags:["shell","1"]}
execute as @e[tag=wave_shell2,tag=!wave_shell1,nbt={Age:1018}] at @s unless entity @e[tag=shell,distance=..7] if block ~ ~ ~ water run summon armor_stand ~ ~-1.82 ~ {Invisible:true,NoGravity:true,Marker:true,Fire:100s,ArmorItems:[{},{},{},{id:nautilus_shell,Count:1b,tag:{CustomModelData:2}}],Tags:["shell","2"]}
execute as @e[tag=wave_shell1,tag=wave_shell2,nbt={Age:1018}] at @s unless entity @e[tag=shell,distance=..7] if block ~ ~ ~ water run summon armor_stand ~ ~-1.82 ~ {Invisible:true,NoGravity:true,Marker:true,Fire:100s,ArmorItems:[{},{},{},{id:nautilus_shell,Count:1b,tag:{CustomModelData:3}}],Tags:["shell","3"]}

# This command will rotate the shells towards the wave that brought them on the shore
execute as @e[tag=shell,scores={wave=1}] at @s run tp @s ~ ~ ~ facing entity @e[tag=wave,limit=1,sort=nearest]

# This command makes sure the shells are kept bright
execute as @e[tag=shell] run data merge entity @s {Fire:100s}


# Each wave also a chance to wash away any shell it touches
execute at @e[tag=wave_spawner,limit=1,sort=random] positioned ~ 63 ~ run execute as @e[tag=wave,distance=..0.35] run tag @s add wave_wash
execute as @e[tag=wave_wash,nbt={Age:1018}] at @s run kill @e[tag=shell,distance=..4]

# These commands make each shell automatically vanish after 1 minute by sinking in the sand
scoreboard players add @e[tag=shell] wave 1
execute as @e[tag=shell,scores={wave=1200..}] at @s run tp @s ~ ~-0.001 ~
kill @e[tag=shell,scores={wave=1350..}]

# This data pack can be used freely; if you do intend to use this data pack for a custom map, you have to credit the creator, PmkExpert, in a visible way.
# Contact on Reddit for any question: https://www.reddit.com/user/Pmk23